# -*- coding: utf-8 -*-

"""
    YtelAPI

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""


class Body(object):

    """Implementation of the 'body' model.

    TODO: type model description here.

    Attributes:
        mfrom (string): A valid Ytel Voice enabled number (E.164 format) that
            will be initiating the phone call.
        to (string): To number
        url (string): URL requested once the call connects
        method (string): Specifies the HTTP method used to request the
            required URL once call connects.
        status_call_back_url (string): URL that can be requested to receive
            notification when call has ended. A set of default parameters will
            be sent here once the call is finished.
        status_call_back_method (string): Specifies the HTTP methodlinkclass
            used to request StatusCallbackUrl.
        fall_back_url (string): URL requested if the initial Url parameter
            fails or encounters an error
        fall_back_method (string): Specifies the HTTP method used to request
            the required FallbackUrl once call connects.
        heart_beat_url (string): URL that can be requested every 60 seconds
            during the call to notify of elapsed tim
        heart_beat_method (string): Specifies the HTTP method used to request
            HeartbeatUrl.
        timeout (int): Time (in seconds) Ytel should wait while the call is
            ringing before canceling the call
        play_dtmf (string): DTMF Digits to play to the call once it connects.
            0-9, #, or *
        hide_caller_id (bool): Specifies if the caller id will be hidden
        record (bool): Specifies if the call should be recorded
        record_call_back_url (string): Recording parameters will be sent here
            upon completion
        record_call_back_method (string): Method used to request the
            RecordCallback URL.
        transcribe (bool): Specifies if the call recording should be
            transcribed
        transcribe_call_back_url (string): Transcription parameters will be
            sent here upon completion
        if_machine (IfMachineEnum): How Ytel should handle the receiving
            numbers voicemail machine
        if_machine_url (string): URL requested when IfMachine=continue
        if_machine_method (string): Method used to request the IfMachineUrl.
        feedback (bool): Specify if survey should be enable or not
        survey_id (string): The unique identifier for the survey.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "mfrom":'From',
        "to":'To',
        "url":'Url',
        "method":'Method',
        "status_call_back_url":'StatusCallBackUrl',
        "status_call_back_method":'StatusCallBackMethod',
        "fall_back_url":'FallBackUrl',
        "fall_back_method":'FallBackMethod',
        "heart_beat_url":'HeartBeatUrl',
        "heart_beat_method":'HeartBeatMethod',
        "timeout":'Timeout',
        "play_dtmf":'PlayDtmf',
        "hide_caller_id":'HideCallerId',
        "record":'Record',
        "record_call_back_url":'RecordCallBackUrl',
        "record_call_back_method":'RecordCallBackMethod',
        "transcribe":'Transcribe',
        "transcribe_call_back_url":'TranscribeCallBackUrl',
        "if_machine":'IfMachine',
        "if_machine_url":'IfMachineUrl',
        "if_machine_method":'IfMachineMethod',
        "feedback":'Feedback',
        "survey_id":'SurveyId'
    }

    def __init__(self,
                 mfrom=None,
                 to=None,
                 url=None,
                 method=None,
                 status_call_back_url=None,
                 status_call_back_method=None,
                 fall_back_url=None,
                 fall_back_method=None,
                 heart_beat_url=None,
                 heart_beat_method=None,
                 timeout=None,
                 play_dtmf=None,
                 hide_caller_id=None,
                 record=None,
                 record_call_back_url=None,
                 record_call_back_method=None,
                 transcribe=None,
                 transcribe_call_back_url=None,
                 if_machine=None,
                 if_machine_url=None,
                 if_machine_method=None,
                 feedback=None,
                 survey_id=None):
        """Constructor for the Body class"""

        # Initialize members of the class
        self.mfrom = mfrom
        self.to = to
        self.url = url
        self.method = method
        self.status_call_back_url = status_call_back_url
        self.status_call_back_method = status_call_back_method
        self.fall_back_url = fall_back_url
        self.fall_back_method = fall_back_method
        self.heart_beat_url = heart_beat_url
        self.heart_beat_method = heart_beat_method
        self.timeout = timeout
        self.play_dtmf = play_dtmf
        self.hide_caller_id = hide_caller_id
        self.record = record
        self.record_call_back_url = record_call_back_url
        self.record_call_back_method = record_call_back_method
        self.transcribe = transcribe
        self.transcribe_call_back_url = transcribe_call_back_url
        self.if_machine = if_machine
        self.if_machine_url = if_machine_url
        self.if_machine_method = if_machine_method
        self.feedback = feedback
        self.survey_id = survey_id


    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary
        mfrom = dictionary.get('From')
        to = dictionary.get('To')
        url = dictionary.get('Url')
        method = dictionary.get('Method')
        status_call_back_url = dictionary.get('StatusCallBackUrl')
        status_call_back_method = dictionary.get('StatusCallBackMethod')
        fall_back_url = dictionary.get('FallBackUrl')
        fall_back_method = dictionary.get('FallBackMethod')
        heart_beat_url = dictionary.get('HeartBeatUrl')
        heart_beat_method = dictionary.get('HeartBeatMethod')
        timeout = dictionary.get('Timeout')
        play_dtmf = dictionary.get('PlayDtmf')
        hide_caller_id = dictionary.get('HideCallerId')
        record = dictionary.get('Record')
        record_call_back_url = dictionary.get('RecordCallBackUrl')
        record_call_back_method = dictionary.get('RecordCallBackMethod')
        transcribe = dictionary.get('Transcribe')
        transcribe_call_back_url = dictionary.get('TranscribeCallBackUrl')
        if_machine = dictionary.get('IfMachine')
        if_machine_url = dictionary.get('IfMachineUrl')
        if_machine_method = dictionary.get('IfMachineMethod')
        feedback = dictionary.get('Feedback')
        survey_id = dictionary.get('SurveyId')

        # Return an object of this model
        return cls(mfrom,
                   to,
                   url,
                   method,
                   status_call_back_url,
                   status_call_back_method,
                   fall_back_url,
                   fall_back_method,
                   heart_beat_url,
                   heart_beat_method,
                   timeout,
                   play_dtmf,
                   hide_caller_id,
                   record,
                   record_call_back_url,
                   record_call_back_method,
                   transcribe,
                   transcribe_call_back_url,
                   if_machine,
                   if_machine_url,
                   if_machine_method,
                   feedback,
                   survey_id)


