# -*- coding: utf-8 -*-

"""
    YtelAPI

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""


class Body71(object):

    """Implementation of the 'body_71' model.

    TODO: type model description here.

    Attributes:
        phone_number (string): A valid comma(,) separated Ytel numbers. (E.164
            format).
        voice_url (string): The URL returning InboundXML incoming calls should
            execute when connected.
        friendly_name (string): A human-readable value for labeling the
            number.
        voice_method (string): Specifies the HTTP method used to request the
            VoiceUrl once incoming call connects.
        voice_fallback_url (string): URL used if any errors occur during
            execution of InboundXML on a call or at initial request of the
            voice url
        voice_fallback_method (string): Specifies the HTTP method used to
            request the VoiceFallbackUrl once incoming call connects.
        hangup_callback (string): URL that can be requested to receive
            notification when and how incoming call has ended.
        hangup_callback_method (string): The HTTP method Ytel will use when
            requesting the HangupCallback URL.
        heartbeat_url (string): URL that can be used to monitor the phone
            number.
        heartbeat_method (string): The HTTP method Ytel will use when
            requesting the HeartbeatUrl.
        sms_url (string): URL requested when an SMS is received.
        sms_method (string): The HTTP method Ytel will use when requesting the
            SmsUrl.
        sms_fallback_url (string): URL used if any errors occur during
            execution of InboundXML from an SMS or at initial request of the
            SmsUrl.
        sms_fallback_method (string): The HTTP method Ytel will use when URL
            requested if the SmsUrl is not available.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "phone_number":'PhoneNumber',
        "voice_url":'VoiceUrl',
        "friendly_name":'FriendlyName',
        "voice_method":'VoiceMethod',
        "voice_fallback_url":'VoiceFallbackUrl',
        "voice_fallback_method":'VoiceFallbackMethod',
        "hangup_callback":'HangupCallback',
        "hangup_callback_method":'HangupCallbackMethod',
        "heartbeat_url":'HeartbeatUrl',
        "heartbeat_method":'HeartbeatMethod',
        "sms_url":'SmsUrl',
        "sms_method":'SmsMethod',
        "sms_fallback_url":'SmsFallbackUrl',
        "sms_fallback_method":'SmsFallbackMethod'
    }

    def __init__(self,
                 phone_number=None,
                 voice_url=None,
                 friendly_name=None,
                 voice_method=None,
                 voice_fallback_url=None,
                 voice_fallback_method=None,
                 hangup_callback=None,
                 hangup_callback_method=None,
                 heartbeat_url=None,
                 heartbeat_method=None,
                 sms_url=None,
                 sms_method=None,
                 sms_fallback_url=None,
                 sms_fallback_method=None):
        """Constructor for the Body71 class"""

        # Initialize members of the class
        self.phone_number = phone_number
        self.voice_url = voice_url
        self.friendly_name = friendly_name
        self.voice_method = voice_method
        self.voice_fallback_url = voice_fallback_url
        self.voice_fallback_method = voice_fallback_method
        self.hangup_callback = hangup_callback
        self.hangup_callback_method = hangup_callback_method
        self.heartbeat_url = heartbeat_url
        self.heartbeat_method = heartbeat_method
        self.sms_url = sms_url
        self.sms_method = sms_method
        self.sms_fallback_url = sms_fallback_url
        self.sms_fallback_method = sms_fallback_method


    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary
        phone_number = dictionary.get('PhoneNumber')
        voice_url = dictionary.get('VoiceUrl')
        friendly_name = dictionary.get('FriendlyName')
        voice_method = dictionary.get('VoiceMethod')
        voice_fallback_url = dictionary.get('VoiceFallbackUrl')
        voice_fallback_method = dictionary.get('VoiceFallbackMethod')
        hangup_callback = dictionary.get('HangupCallback')
        hangup_callback_method = dictionary.get('HangupCallbackMethod')
        heartbeat_url = dictionary.get('HeartbeatUrl')
        heartbeat_method = dictionary.get('HeartbeatMethod')
        sms_url = dictionary.get('SmsUrl')
        sms_method = dictionary.get('SmsMethod')
        sms_fallback_url = dictionary.get('SmsFallbackUrl')
        sms_fallback_method = dictionary.get('SmsFallbackMethod')

        # Return an object of this model
        return cls(phone_number,
                   voice_url,
                   friendly_name,
                   voice_method,
                   voice_fallback_url,
                   voice_fallback_method,
                   hangup_callback,
                   hangup_callback_method,
                   heartbeat_url,
                   heartbeat_method,
                   sms_url,
                   sms_method,
                   sms_fallback_url,
                   sms_fallback_method)


