# -*- coding: utf-8 -*-

"""
    YtelAPI

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

import jsonpickle
import dateutil.parser
from .controller_test_base import ControllerTestBase
from ..test_helper import TestHelper
from YtelAPI.api_helper import APIHelper


class DedicatedShortCodeControllerTests(ControllerTestBase):

    @classmethod
    def setUpClass(cls):
        super(DedicatedShortCodeControllerTests, cls).setUpClass()
        cls.controller = cls.api_client.dedicated_short_code

    # Retrieve a list of Short Code assignment associated with your Ytel account.
    def test_test_list_shortcodes(self):
        # Parameters for the API call
        shortcode = None
        page = None
        pagesize = None

        # Perform the API call through the SDK function
        result = self.controller.create_list_shortcodes(shortcode, page, pagesize)

        # Test response code
        self.assertEquals(self.response_catcher.response.status_code, 200)

        # Test headers
        expected_headers = {}
        expected_headers['content-type'] = 'application/json'

        self.assertTrue(TestHelper.match_headers(expected_headers, self.response_catcher.response.headers))


    # Retrive a list of inbound Sms Short Code messages associated with your Ytel account.
    def test_test_list_inbound_sms(self):
        # Parameters for the API call
        page = None
        pagesize = None
        mfrom = None
        shortcode = None
        datecreated = None

        # Perform the API call through the SDK function
        result = self.controller.create_list_inbound_sms(page, pagesize, mfrom, shortcode, datecreated)

        # Test response code
        self.assertEquals(self.response_catcher.response.status_code, 200)

        # Test headers
        expected_headers = {}
        expected_headers['content-type'] = 'application/json'

        self.assertTrue(TestHelper.match_headers(expected_headers, self.response_catcher.response.headers))


    # Retrieve a list of Short Code messages.
    def test_test_list_sms(self):
        # Parameters for the API call
        shortcode = None
        to = None
        date_sent = None
        page = None
        page_size = None

        # Perform the API call through the SDK function
        result = self.controller.create_list_sms(shortcode, to, date_sent, page, page_size)

        # Test response code
        self.assertEquals(self.response_catcher.response.status_code, 200)

        # Test headers
        expected_headers = {}
        expected_headers['content-type'] = 'application/json'

        self.assertTrue(TestHelper.match_headers(expected_headers, self.response_catcher.response.headers))


